/*
 * httpPost.c
 *
 * This software is provided as-is.  Lantronix and the author disclaim to the fullest 
 * extent authorized by law any and all warranties, whether express or implied, 
 * including, without limitation, any implied warranties of title, non-infringement, 
 * merchantability or fitness for a particular purpose.   Neither the author nor 
 * Lantronix are responsible for any damage or losses of any kind caused by the use or 
 * misuse of this software.  IN NO EVENT SHALL THE AUTHOR OR LANTRONIX BE 
 * LIABLE FOR ANY DAMAGES, INCLUDING  INCIDENTAL OR CONSEQUENTIAL 
 * DAMAGES, IN CONNECTION WITH OR ARISING FROM THE FURNISHING, 
 * PERFORMANCE, OR USE OF THIS SOFTWARE.
 * 
 */

#define POST_BUFFER_MAX	1024

int createPostMessage(char postBuffer[], char data[], char port[], char uid[]) {
	char formBoundary[] = "--xyz33kdejfkasdf--";
	char contentDisposition[] = "Content-Disposition: form-data";
	char scratchBuffer[512];
	char headerString[] = 
		"POST /ltxpost HTTP/1.1\r\n"
		"Host: ltrxpost.appspot.com\r\n"
		"Connection: keep-alive\r\n"
		"Content-Length: %d\r\n"
		"Content-Type: multipart/form-data; boundary=%s\r\n"
		"Accept: */*\r\n"
		"\r\n"
		"%s";	// content

	char contentString[] = 
		"--%s\r\n"					// boundary
		"%s;name=\"Data\"\r\n\r\n"
		"%s\r\n"
		"--%s\r\n"					// boundary
		"%s;name=\"Port\"\r\n\r\n"
		"%s\r\n"
		"--%s\r\n"					// boundary
		"%s;name=\"Uid\"\r\n\r\n"
		"%s\r\n"
		"--%s--\r\n";					// boundary
	                   
	                   
	int size = snprintf(scratchBuffer, 512, contentString, 
			formBoundary, contentDisposition, data, 
			formBoundary, contentDisposition, port, 
			formBoundary, contentDisposition, uid, formBoundary);
	
	size = snprintf(postBuffer, POST_BUFFER_MAX, headerString, size, formBoundary, scratchBuffer );
	return size;
}
